'' Jim Bagley's Pixel Power Renderer

VAR
  long  cog

PUB start(jb_pp_ptr) : okay
  okay := (cog := cognew(@entry,jb_pp_ptr)) > 0

DAT
        org
entry   mov   t1,PAR
        rdlong cog_num,t1
        add   t1,#4
        rdlong vsyncptr,t1
        add   t1,#4
        rdlong scrptr,t1
        add   t1,#4
        rdlong clsptr,t1
        add   t1,#4
        rdlong clslen,t1
        add   t1,#4
        rdlong pixels,t1
        add   t1,#4
        rdlong pixstp,t1
        add   t1,#4
        rdlong numpix,t1
loop    rdlong t1,vsyncptr wz
  if_z  jmp   #loop

        mov   t1,PAR
        add   t1,#32
        rdlong exploding,t1
        add   t1,#4
        rdlong frame,t1
     
        mov   t1,clsptr
        mov   t2,clslen
:clslp  wrlong zero,t1
        add   t1,#4
        djnz  t2,#:clslp                          

        mov   t1,pixels
        mov   t2,numpix
:drawlp
        rdlong t3,t1
        mov   t4,t3
        and   t4,#255
        mov   t7,t4
        and   t7,#7
        add   t7,#pixtab
        movs  :rdp,t7
        mov   t5,t3
        shr   t5,#8-5
        and   t5,ffshl5
        cmp   t5,c0shl5 wc,wz
        mov   t6,t5
        add   t6,scrptr
        mov   t7,t4
        shr   t7,#3
        add   t6,t7
:rdp    mov   t7,pixtab
        rdbyte t5,t6
        or    t5,t7
        add   t1,pixstp
  if_b  wrbyte t5,t6
        djnz  t2,#:drawlp

        test  exploding,#2 wz
  if_nz jmp   #loop

        mov   t1,pixels
        mov   t2,numpix
:movelp

'        mov   t3,t2
'        add   t3,frame
'        and   t3,#3 wz
'  if_nz jmp   #:skip

        rdlong t3,t1
        mov   t5,t3
        and   t5,ff00
        cmp   t5,e000 wc,wz
  if_ae jmp   #:justabove
        cmp   t5,c000 wc,wz
  if_ae jmp   #:skip
:justabove
        mov   t4,t3
        and   t4,#255
        mov   t6,t3
        shr   t6,#16
        mov   t7,t6
        and   t6,#255
        and   t7,ff00
        add   t4,t6
        and   t4,#$ff
        add   t5,t7
        and   t5,ff00
        or    t4,t5

        mov   t6,t2
        add   t6,frame
        and   t6,#7 wz
  if_nz jmp   #:skp1
        test  exploding,#1 wz
  if_nz add   t3,add1ys
:skp1   and   t3,ffff0000
        or    t3,t4
        wrlong t3,t1
:skip
        add   t1,pixstp
        djnz  t2,#:movelp
        
        jmp   #loop        

add1ys  long $01000000
ffff0000 long $ffff0000
ffshl5  long  $ff<<5
c0shl5  long  $b8<<5
ff00    long  $ff00
c000    long  $b800
e000    long  $e000

zero    long  0
pixtab  long  %10000000
        long  %01000000
        long  %00100000
        long  %00010000
        long  %00001000
        long  %00000100
        long  %00000010
        long  %00000001

cog_num res   1
vsyncptr res  1
scrptr  res   1
clsptr  res   1
clslen  res   1
pixels  res   1
pixstp  res   1
numpix  res   1
exploding res 1
frame   res   1

t1      res   1
t2      res   1
t3      res   1
t4      res   1
t5      res   1
t6      res   1
t7      res   1

        fit

PUB bang(jb_pp_ptr) : okay
  okay := (cog := cognew(@explode,jb_pp_ptr)) > 0

DAT
        org
explode mov   t1,PAR
        add   t1,#20
        rdlong pixels,t1
        add   t1,#8
        rdlong numpix,t1
        add   t1,#4
        wrlong val1,t1
        mov   t1,pixels
        mov   t2,numpix
        add   t1,#2
explp   mov   t3,cnt
        mov   t4,t3
        shr   t3,#4
        and   t3,#15
        add   t3,#exptabx
        movs  gxad,t3
        shr   t4,#7
        and   t4,#15
        add   t4,#exptabx
        movs  gyad,t4
gxad    mov   t4,exptabx            
gyad    mov   t3,exptabx
        shl   t3,#8
        or    t3,t4
        wrword t3,t1        
        add   t1,#4
        djnz  t2,#explp
        cogid cognm
        cogstop cognm

val1    long  1

exptabx long  -4,-3,-2,-1,0,1,2,3,4,3,2,1,0,-1,-2,-3

cognm   res   1        
                